<?php
/**
 * Based on book module's block
 */

namespace Drupal\book_blocks\Plugin\Block;

use Drupal\node\Entity\Node;
use Drupal\book\BookManager;
use Drupal\Core\Block\BlockBase;
use Drupal\book\BookManagerInterface;
//use Drupal\Core\Cache\Cache;
//use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
//use Drupal\node\NodeInterface;
//use Symfony\Component\DependencyInjection\ContainerInterface;
//use Symfony\Component\HttpFoundation\RequestStack;
use Drupal\Core\Entity\EntityStorageInterface;
use Drupal\Core\Url;

/**
 * Provides bas class for another 'Book navigation' block.
 *
 */
abstract class BookBlocksBlockBase extends BlockBase implements ContainerFactoryPluginInterface {

  /**
   * The request object.
   *
   * @var \Symfony\Component\HttpFoundation\RequestStack
   */
  protected $requestStack;

  /**
   * The book manager.
   *
   * @var \Drupal\book\BookManagerInterface
   */
  protected $bookManager;

  /**
   * The node storage.
   *
   * @var \Drupal\Core\Entity\EntityStorageInterface
   */
  protected $nodeStorage;

  /**
   * Get node URL from nid
   *
   * @param int $nid
   *
   * @return string
   */
  function node_url($nid) {
    return Url::fromRoute('entity.node.canonical', ['node' => $nid])->toString();
  }
}

